//处理用户添加的数据
function getFontsJson() {
  // alert(app.activeDocument.textFrames.length)
  infoList = [];
  doc = app.activeDocument;
  for (i = 0; i < doc.textFrames.length; i++) {
    obj = new Object();
    obj.width = doc.textFrames[i].width;
    obj.height = doc.textFrames[i].height;
    obj.position = doc.textFrames[i].position;
    obj.contents = doc.textFrames[i].contents;
    obj.top = doc.textFrames[i].top;
    obj.left = doc.textFrames[i].left;
    obj.type = "font";
    infoList.push(obj);
  }
  return JSON.stringify(infoList);
}
function getPutJson() {
  infoList = [];
  doc = app.activeDocument;
  for (i = 0; i < doc.rasterItems.length; i++) {
    file = doc.rasterItems[i].file;
    obj = new Object();
    obj.width = doc.rasterItems[i].width;
    obj.height = doc.rasterItems[i].height;
    obj.position = doc.rasterItems[i].position;
    obj.top = doc.rasterItems[i].top;
    obj.left = doc.rasterItems[i].left;
    obj.fileName = doc.rasterItems[i].file.name;
    obj.type = "img";
    obj.file = "data:image/png;base64," + base64(file);
    infoList.push(obj);
  }
  return JSON.stringify(infoList);
}
function getOuterJson() {
  infoList = [];
  doc = app.activeDocument;
  for (i = 0; i < doc.placedItems.length; i++) {
    file = doc.placedItems[i].file;
    obj = new Object();
    obj.width = doc.placedItems[i].width;
    obj.height = doc.placedItems[i].height;
    obj.position = doc.placedItems[i].position;
    obj.top = doc.placedItems[i].top;
    obj.left = doc.placedItems[i].left;
    obj.type = "img";
    obj.fileName = doc.placedItems[i].file.name;
    obj.file = "data:image/png;base64," + base64(file);
    infoList.push(obj);
  }
  return JSON.stringify(infoList);
}
//处理复合路径的svg
function compoundPathItems() {
  infoList = [];
  doc = app.activeDocument;
  for (i = 0; i < doc.compoundPathItems.length; i++) {
    obj = new Object();
    obj.width = doc.compoundPathItems[i].width;
    obj.height = doc.compoundPathItems[i].height;
    obj.position = doc.compoundPathItems[i].position;
    obj.top = doc.compoundPathItems[i].top;
    obj.left = doc.compoundPathItems[i].left;
    // obj.wrapOffset = doc.compoundPathItems[i].wrapOffset;
    // obj.controlBounds = doc.compoundPathItems[i].controlBounds;
    obj.visibleBounds = doc.compoundPathItems[i].visibleBounds;
    // obj.geometricBounds = doc.compoundPathItems[i].geometricBounds;
    obj.type = "img";
    infoList.push(obj);
  }
  return JSON.stringify(infoList);
}
//处理单路径的svg
function handleLonePathItems(pathItemLn) {
  infoList = [];
  doc = app.activeDocument;
  //当前刀线的数量
  nowPathLn = doc.pathItems.length;
  for (i = 0; i < nowPathLn - pathItemLn; i++) {
    obj = new Object();
    obj.width = doc.pathItems[i].width;
    obj.height = doc.pathItems[i].height;
    obj.position = doc.pathItems[i].position;
    obj.top = doc.pathItems[i].top;
    obj.left = doc.pathItems[i].left;
    obj.visibleBounds = doc.pathItems[i].visibleBounds;
    obj.type = "img";
    infoList.push(obj);
  }
  return JSON.stringify(infoList);
}
function getNewPathJson(num) {
  infoList = [];
  doc = app.activeDocument;
  for (i = 0; i < doc.pathItems.length; i++) {
    obj = new Object();
    obj.width = doc.pathItems[i].width;
    obj.height = doc.pathItems[i].height;
    // obj.position = doc.pathItems[i].position;
    obj.top = doc.pathItems[i].top;
    obj.left = doc.pathItems[i].left;
    obj.controlBounds = doc.pathItems[i].controlBounds;
    infoList.push(obj);
  }
  return JSON.stringify(infoList);
}
