// 文字获取颜色
function getColor(item) {
  var rColor = item.red || 0;
  var gcolor = item.green || 0;
  var bcolor = item.blue || 0;
  return "rgb(" + rColor + "," + gcolor + "," + bcolor + ")";
}

//获取文字对齐方式
function getTextAlign(str) {
  if (str === Justification.LEFT) {
    return "left";
  } else if (str === Justification.RIGHT) {
    return "right";
  } else if (str === Justification.FULLJUSTIFYLASTLINELEFT) {
    return "justify";
  } else {
    return "center";
  }
}

//获取文字间距
function getTextSpacing(ele) {
  if (ele.textRange.characterAttributes.tracking) {
    return Math.round(ele.textRange.characterAttributes.tracking / 1000);
  } else {
    return 0;
  }
}

//获取文字方向
function getTextVertical(str) {
  if (str === TextOrientation.VERTICAL) {
    return 1;
  } else {
    return 0;
  }
}
//获取文字是不是斜体
function getTextStyle(ele) {
  if (ele.textRange.characterAttributes.italics) {
    return "italic";
  } else {
    return "normal";
  }
}
// 获取文字的下划线类型 web只能存在一个
function getTextDecoration(obj) {
  if (obj.underline) {
    return "underline";
  }
  if (obj.strikeThrough) {
    return "line-through";
  }
  return "none";
}

// 获取文字的行间距

function getTetxLineHeight(ele) {
  if (ele.textRange.characterAttributes.autoLeading) {
    return ele.height;
  } else {
    return (
      ele.textRange.characterAttributes.leading +
      (ele.textRange.characterAttributes.leading - ele.textRange.size) / 2
    );
  }
}

// 判断文字是toSvg还是toText 包小盒的编辑器有许多特性不支持为了还原度把不支持的转化SVG
// 根据AI CEP 的api 判断 可能不全
// return ture // toText 反之亦然
function getJudgeTextLayer(ele) {
  // 暂时能理解的只有描边，先简单判断一下
  // ai文字默认描边值为1
  $.write(ele.textRange.characterAttributes.strokeWeight, "kkkkkkkk");
  if (
    ele.textRange.characterAttributes.strokeWeight === 1 ||
    !ele.textRange.characterAttributes.strokeWeight
  ) {
    return false;
  } else {
    return true;
  }
  //  ele.textRange
}

/**
 * 解析ai的dom对象
 */
function aiParseText(ele) {
  // 获取当前文档所有图层
  // var desgins = app.activeDocument.layers;
  var desginsList = [];
  // for (var i = 0; i < desgins.length; i++) {
  //   var item = desgins[i].pageItems;
  //   for (var j = 0; j < item.length; j++) {
  // var ele = item[j];
  //  $.writeln(ele)
  var obj = new Object();
  // 记录有内容的文本 没有内容就不管
  // 有描边
  if (ele.contents) {
    obj.width = ele.width;
    obj.height = ele.height;
    obj.top = ele.top;
    obj.left = ele.left;
    obj.value = ele.contents;
    obj.fontSize = ele.textRange.size;
    obj.opacity = ele.opacity;
    obj.vertical = getTextVertical(ele.orientation);
    obj.color = getColor(ele.textRange.fillColor);
    obj.family = ele.textRange.characterAttributes.textFont.name; //postsciptname
    obj.textAlign = getTextAlign(ele.textRange.justification);
    obj.letterSpacing = getTextSpacing(ele);
    obj.fontStyle = getTextStyle(ele);
    obj.fontWeight = "normal"; // ai 文字加粗通过切换字体和描边来处理所以不处理
    obj.textDecoration = getTextDecoration(ele.textRange.characterAttributes);
    obj.rotate = ele.textRange.characterAttributes.rotation || 360;
    obj.lineHeight = getTetxLineHeight(ele);
    obj.type = "font";
    obj.zindex = ele.absoluteZOrderPosition;
    desginsList.push(obj);
    return obj;
  } else {
    return "";
  }
  //   }
  // }
}

function deepKnifeLarer(layer, obj) {
  var knifePageItems = layer.pageItems;
  // debugger;

  if (knifePageItems.length) {
    //  找到 mixX
    var xArr = [];
    for (var i = 0; i < knifePageItems.length; i++) {
      var itemX = knifePageItems[i].left || 0;
      xArr.push(itemX);
    }
    var minX = xArr[0];
    for (var j = 0; j < xArr.length; j++) {
      if (minX < xArr[j]) {
        minX = xArr[j];
      }
    }
    obj.xMin = minX;
  }
  if (layer.layers) {
    for (var i = 0; i < layer.layers.length; i++) {
      deepKnifeLarer(layer.layers[i], obj);
    }
  }
}

// ai 的xy是第一象限而 web是第四象限 进行一下换算
// 统一+上 画布的height 然后在把坐标转化的刀线上
function knifeLayerTopLeft() {
  // 文档高度
  var activeDocumentHeight = app.activeDocument.height;
  var allLayer_knife = app.activeDocument.layers;
  var knifeObj = {
    height: activeDocumentHeight,
    xMin: 0,
  };
  var knifeLayer;
  for (var i = 0; i < allLayer_knife.length; i++) {
    var knife_layer = allLayer_knife[i];
    //  当刀线层
    if (knife_layer.name.indexOf("删改或移动") !== -1) {
      // deepKnifeLarer(knife_layer, knifeObj);
      knifeLayer = knife_layer;
      break;
    } else {
      continue;
    }
  }
  var c = knifeLayer;
  if (knifeLayer) {
    deepKnifeLarer(knifeLayer, knifeObj);
  }
  return JSON.stringify(knifeObj);
}

// knifeLayerTopLeft();
