#include "./aiTextToWebData.jsx"

function exportPNG24A(path) {
    var n = getUUID();
    var fullpath = path + n;
    doc = app.activeDocument;
    var exportOptions = new ExportOptionsPNG24();
    var type = ExportType.PNG24;
    var fileSpec = new File(fullpath);
    // exportOptions.antiAliasing = false;
    exportOptions.transparency = true;
    // exportOptions.saveAsHTML = true;
    // exportOptions.artBoardClipping = true;
    app.activeDocument.exportFile(fileSpec, type, exportOptions);
    return fullpath + ".png";
}

function randomCoding() {
    var number = "";
    var n = 4;
    for (var i = 0; i < n; i++) {
        number += Math.floor(Math.random() * 10);
    }
    return number;
}

function S4() {
    return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
}

function getUUID() {
    return S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4();
}

function packageImgObj(obj, path, imgType) {
    var name = "";
    if (!!obj.name) {
        name = obj.name;
    } else if (obj.typename === "RasterItem") {
        name = "图层-图片";
    } else {
        name = "图层-图形";
    }
    var result = new Object();
    result.name = name;
    result.width = obj.width;
    result.height = obj.height;
    result.top = obj.top;
    result.left = obj.left;
    // if(obj.)
    result.zindex = obj.absoluteZOrderPosition;
    // $.write('width', obj.width)
    // $.write('height', obj.height)

    result.srcpath = path;
    result.type = "img";
    // svg1 png 0
    result.can_set_color = imgType === "svg" ? 1 : 0;
    return result;
}

function exportFileAsSvgA(path) {
    // var path = decodeURI(this.$store.state.imgPath);
    var n = getUUID();
    var fullpath = path + n;
    const options = new ExportOptionsWebOptimizedSVG();

    options.compressed = false;
    options.coordinatePrecision = 3;
    options.cssProperties = SVGCSSPropertyLocation.PRESENTATIONATTRIBUTES;
    options.fontSubsetting = SVGFontSubsetting.None;
    options.fontType = SVGFontType.SVGFONT;
    // options.DTD = SVGDTDVersion.SVGTINY1_2
    // options.sVGTextOnPath = true
    var fileSpec = new File(fullpath);
    options.svgResponsive = false;
    app.activeDocument.exportFile(fileSpec, ExportType.WOSVG, options);
    return fullpath + ".svg";
}

function revertVisiable(item, visiable) {
    if (typeof item.hidden !== "boolean") return;
    if (item.typename === "PathItem" && item.clipping) {
        item.hidden = false;
    } else {
        item.hidden = !visiable;
    }
}

function resetAllVisiable(itemList, visiable) {
    for (var i = 0; i < itemList.length; i++) {
        var item = itemList[i];
        // item.hidden = true;
        revertVisiable(item, visiable);
    }
}

function resetAllLayersVisiable(itemList, visiable) {
    for (var i = 0; i < itemList.length; i++) {
        var item = itemList[i];
        item.visible = visiable;
    }
}

function judgeLayerClip(arr) {
    var flag
    for (var i = 0; i < arr.length; i++) {
        if (arr[i].typename === 'PathItem' && arr[i].clipping) {
            flag = true
            break
        }
    }
    return flag
}
// 把组里面的文字变成path
// 进来的都是pageitems 整个导出的时候才走的逻辑
function doCyclePageItemAndTextToPath(arr) {
    for (var i = 0; i < arr.length; i++) {
        // var arri = arr[i]
        if (arr[i].typename === "TextFrame") {

            arr[i].createOutline()
        } else if (arr[i].typename === 'GroupItem') {
            if (arr[i].pageItems.length) {
                doCyclePageItemAndTextToPath(arr[i].pageItems)
            }
        }
        // 下面可能存在图层
        if (arr[i].layers) {
            for (var j = 0; j < arr[i].layers; j++) {
                if (arr[i][j].pageItems.length) {
                    doCyclePageItemAndTextToPath(arr[i][j].pageItems)
                }
            }
        }
    }
}

// 
function doSizeClipGroupItemTopLeft(arr, sizeObj) {

    // // 相同一层可能有多个裁剪路径
    // for (var i =0 ;i< arr.length; i++) {
    //     //找到clipItem
    //     if (arr[i].clipping) {
    //         sizeObj.clipItem.push(arr[i]) 
    //     }
    // }
    // var copySizeObj = JSON.parse(JSON.stringify(sizeObj))
    // // 把所有元素和裁剪框对比 取交集 转化最大的left top

    // for (var j =0 ; j<arr.length;j++) {
    //     if (arr[j].typename !== 'GroupItem') {
    //         var copyClipItem = copySizeObj.clipItem
    //          // 元素的位置 
    //             var itemLeft =  arr[j].left
    //             var itemTop = arr[j].top
    //             var itemRight = arr[j].left + arr[j].width
    //             var itemBottom = arr[j].top + arr[j].height
    //             var itemCutTop =  itemTop
    //             var itemCutLeft =  itemLeft
    //         for (var k = 0; k<copyClipItem.length;k++) {
    //             // 裁剪框的位置
    //             var catLeft = copyClipItem[k].left
    //             var catTop =  copyClipItem[k].top
    //             var catRight = copyClipItem[k].left + copyClipItem[k].width
    //             var carBottom = copyClipItem[k].top - copyClipItem[k].height

    //         }

    //     } else {
    //        doSizeClipGroupItemTopLeft(arr[j].pageItems,sizeObj) 
    //     }
    // }
    // 找到minX maxy
    for (var i = 0; i < arr.length; i++) {
        // if (!arr[i].clipping) {
        if (arr[i].typename === 'GroupItem') {
            if (arr[i].pageItems && arr[i].pageItems.length) {
                doSizeClipGroupItemTopLeft(arr[i].pageItems, sizeObj)
            }

        } else {
            //   debugger
            //   var q = arr[i] 
            if (arr[i].clipping) {
                continue
            }
            if (sizeObj.top === '') {
                sizeObj.top = arr[i].top
            }
            if (sizeObj.left === '') {
                sizeObj.left = arr[i].left
            }
            if (sizeObj.right === '') {
                sizeObj.right = arr[i].controlBounds[2] || 0
            }
            if (sizeObj.bottom === '') {
                sizeObj.bottom =  arr[i].controlBounds[3] || 0
            }
            if (arr[i].top >= sizeObj.top) {
                sizeObj.top = arr[i].top
            }
            if (arr[i].left <= sizeObj.left) {
                sizeObj.left = arr[i].left
            }

            if ( arr[i].controlBounds[3] <= sizeObj.bottom) {
                sizeObj.bottom =  arr[i].controlBounds[3]
            }
            if (arr[i].controlBounds[2]>= sizeObj.right) {
                sizeObj.right = arr[i].controlBounds[2]
            }
        }
        // }
    }
}

function parsingPageItems(arr, num, exportFileInfo, savePath, recordInfo) {
    //num 为层级深度 recordInfo 为计算整体要导出的元素数量
    if (!arr.length) {
        return
    }
    var parent = arr[0].parent;
    if (arr.length > 10 || num > 3) {
        // debugger
        
        if (parent.typename === "GroupItem") {
            if (recordInfo) {
                recordInfo.eleNumber++
                return
            }
            doCyclePageItemAndTextToPath(arr)
            parent.hidden = false;
            // var path = exportPNG24A(savePath);
            var path = exportFileAsSvgA(savePath);
            var imgInfo = packageImgObj(parent, path, "svg");
            //cutgroup
            exportFileInfo.push(imgInfo);
            // // $.write(deepTextToPath.num)

            parent.hidden = true;
            return;
        }
        // 如果父级是layer 不做处理
    }
    // 隐藏全部 pageitem
    if (arr.length > 1) {
        resetAllVisiable(arr, false);
    }
    for (var i = 0; i < arr.length; i++) {
        // $.write(arr[i].typename);
        //         if(i===16){
        // debugger

        //         }
        if (arr[i].typename === "TextFrame") {
            // 有没有内容
            // debugger
            var aiTextFrom = aiParseText(arr[i]);
            // 是否转化SVG
            // if (getJudgeTextLayer(pageItems[j])) {
            if (aiTextFrom) {
                exportFileInfo.push(aiTextFrom);
            }
        } else if (arr[i].typename === "RasterItem") {
            if (arr[i].opacity) {
                if (recordInfo) {
                    recordInfo.eleNumber++
                } else {
                    arr[i].hidden = false;
                    var path = exportPNG24A(savePath);
                    var imgInfo = packageImgObj(arr[i], path, "png");
                    exportFileInfo.push(imgInfo);
                    arr[i].hidden = true;
                }
            };
        } else if (
            arr[i].typename === "PathItem" ||
            arr[i].typename === "GraphItem" ||
            arr[i].typename === "CompoundPathItem"
        ) {
            if (arr[i].opacity) {
                if (recordInfo) {
                    recordInfo.eleNumber++
                } else {
                    arr[i].hidden = false;
                    var path = exportFileAsSvgA(savePath);
                    var imgInfo = packageImgObj(arr[i], path, "svg");
                    exportFileInfo.push(imgInfo);
                    arr[i].hidden = true;
                }
            };


        } else if (arr[i].typename === "GroupItem") {
            // $.write('GroupItemwidth', arr[i].width)
            // $.write('GroupItemheight', arr[i].height)
            // debugger
            // var arri = arr[i]
            if (arr[i].clipped) {
                if (recordInfo) {
                    recordInfo.eleNumber++
                } else {
                    doCyclePageItemAndTextToPath(arr[i].pageItems)
                    var sizeObj = new Object()
                    sizeObj.top = ''
                    sizeObj.left = ''
                    sizeObj.right = ''
                    sizeObj.bottom = ''
                    // sizeObj.clipItem = []
                    // debugger
                    doSizeClipGroupItemTopLeft(arr[i].pageItems, sizeObj)
                    arr[i].hidden = false;
                    var path = exportFileAsSvgA(savePath);
                    var imgInfo = packageImgObj(arr[i], path, "svg");
                    //cutgroup

                    imgInfo.isClip = true
                    if (sizeObj.top || sizeObj.left) {
                        imgInfo.maxTop = sizeObj.top
                        imgInfo.minLeft = sizeObj.left
                        imgInfo.imgWidth = sizeObj.right - sizeObj.left
                        // $.write( Math.abs(sizeObj.bottom +sizeObj.top ) )
                       // 可能有问题
                        imgInfo.imgHeight =Math.abs(Math.abs(sizeObj.bottom) - Math.abs(sizeObj.top)) 
                        
                       
                    }

                    exportFileInfo.push(imgInfo);
                    arr[i].hidden = true;

                }
                continue
            } else {
                arr[i].hidden = false;
                num = num + 1;
                parsingPageItems(arr[i].pageItems, num, exportFileInfo, savePath, recordInfo);
                arr[i].hidden = true;
            }

        } else {
            if (recordInfo) {
                recordInfo.eleNumber++
            } else {
                arr[i].hidden = false;
                var path = exportPNG24A(savePath);
                var imgInfo = packageImgObj(arr[i], path, "png");
                exportFileInfo.push(imgInfo);
                arr[i].hidden = true;
            }

        }


        if (arr[i].layers) {
            parsingLayer(arr[i].layers, exportFileInfo, saveFilePath);
        }
    }
    // 恢复全部 pageitem
    resetAllVisiable(arr, true);

}

function parsingLayer(layers, exportFileInfo, saveFilePath, recordInfo) {
    for (var i = 0; i < layers.length; i++) {
        // 跳过刀线图层
        if (layers[i].name.indexOf("删改或移动") !== -1) {
            continue;
        }
        var layerLocked = false
        if (layers[i].locked) {
            // continue;
            layers[i].locked = !layers[i].locked 
            layerLocked = true

        }

        // 若存在多图层,在处理当前图层时隐藏其他图层
        if (layers.length > 1) {
            resetAllLayersVisiable(layers, false);
            layers[i].visible = true;
        }
        // debugger;

        // 拿到所有的PageItems
        var layerPageItems = layers[i].pageItems;
        if (!layerPageItems.length) {
            continue
        }
        var num = 0;
        parsingPageItems(layerPageItems, num, exportFileInfo, saveFilePath, recordInfo);
        // 下面可能还有layers
        if (layers[i].layers) {
            parsingLayer(layers[i], exportFileInfo, saveFilePath, recordInfo);
        }

        if (layerLocked) {
              layers[i].locked = true
        }

    }
    // 恢复全部图层显示
    resetAllLayersVisiable(layers, true);

}

function getParsingAiLength() {
    var exportFileInfo = [];
    var saveFilePath = "";
    var recordInfo = new Object()
    recordInfo.eleNumber = 0
    var documentsLayer = app.activeDocument.layers;
    parsingLayer(documentsLayer, exportFileInfo, saveFilePath, recordInfo);
    return recordInfo.eleNumber
}

function parsingAi(saveFilePath) {
    var exportFileInfo = [];
    // 转化颜色空间
    var colorFormat = app.activeDocument.documentColorSpace
    if (colorFormat === DocumentColorSpace.CMYK) {
        app.executeMenuCommand("doc-color-rgb")
    }
    // var saveFilePath = "C:/Users/mingo/Documents/picture";
    // 获取layers
    var documentsLayer = app.activeDocument.layers;
    parsingLayer(documentsLayer, exportFileInfo, saveFilePath);
    if (colorFormat === DocumentColorSpace.CMYK) {
        app.executeMenuCommand("doc-color-cmyk")
    }
    return JSON.stringify(exportFileInfo);
    // return exportFileInfo);
}

// parsingAi();
// getParsingAiLength()