#include "./aiTextToWebData.jsx"

function exportPNG24A(path) {
    var n = getUUID();
    var fullpath = path + n;
    doc = app.activeDocument;
    var exportOptions = new ExportOptionsPNG24();
    var type = ExportType.PNG24;
    var fileSpec = new File(fullpath);
    // exportOptions.antiAliasing = false;
    exportOptions.transparency = true;
    // exportOptions.saveAsHTML = true;
    // exportOptions.artBoardClipping = true;
    app.activeDocument.exportFile(fileSpec, type, exportOptions);
    return fullpath + ".png";
}

function randomCoding() {
    var number = "";
    var n = 4;
    for (var i = 0; i < n; i++) {
        number += Math.floor(Math.random() * 10);
    }
    return number;
}

function S4() {
    return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
}

function getUUID() {
    return S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4();
}

function packageImgObj(obj, path, imgType) {
    var name = "";
    if (!!obj.name) {
        name = obj.name;
    } else if (obj.typename === "RasterItem") {
        name = "图层-图片";
    } else {
        name = "图层-图形";
    }
    var result = new Object();
    result.name = name;
    result.width = obj.width;
    result.height = obj.height;
    result.top = obj.top;
    result.left = obj.left;
    result.zindex = obj.absoluteZOrderPosition;


    result.srcpath = path;
    result.type = "img";
    // svg1 png 0
    result.can_set_color = imgType === "svg" ? 1 : 0;
    return result;
}

function exportFileAsSvgA(path) {
    // var path = decodeURI(this.$store.state.imgPath);
    var n = getUUID();
    var fullpath = path + n;
    const options = new ExportOptionsWebOptimizedSVG();

    options.compressed = false;
    options.coordinatePrecision = 3;
    options.cssProperties = SVGCSSPropertyLocation.PRESENTATIONATTRIBUTES;
    options.fontSubsetting = SVGFontSubsetting.None;
    options.fontType = SVGFontType.SVGFONT;
    // options.DTD = SVGDTDVersion.SVGTINY1_2
    // options.sVGTextOnPath = true
    var fileSpec = new File(fullpath);
    options.svgResponsive = false;
    app.activeDocument.exportFile(fileSpec, ExportType.WOSVG, options);
    return fullpath + ".svg";
}

function revertVisiable(item, visiable) {
    if (typeof item.hidden !== "boolean") return;
    if (item.typename === "PathItem" && item.clipping) {
        item.hidden = false;
    } else {
        item.hidden = !visiable;
    }
}

function resetAllVisiable(itemList, visiable) {
    for (var i = 0; i < itemList.length; i++) {
        var item = itemList[i];
        // item.hidden = true;
        revertVisiable(item, visiable);
    }
}

function resetAllLayersVisiable(itemList, visiable) {
    for (var i = 0; i < itemList.length; i++) {
        var item = itemList[i];
        item.visible = visiable;
    }
}

function judgeLayerClip(arr) {
    var flag
    for (var i = 0; i < arr.length; i++) {
        if (arr[i].typename === 'PathItem' && arr[i].clipping) {
            flag = true
            break
        }
    }
    return flag
}
// 进来的都是pageitems 整个导出的时候才走的逻辑
function doCyclePageItemAndTextToPath(arr, num) {
    for (var i = 0; i < arr.length; i++) {
        if (arr[i].typename === "TextFrame") {
            num++
            arr[i].createOutline()
        } else if (arr[i].typename === 'GroupItem') {
            if (arr[i].pageItems.length) {
                doCyclePageItemAndTextToPath(arr[i].pageItems, num)
            }
        }
        // 下面可能存在图层
        if (arr[i].layers) {
            for (var j = 0; j < arr[i].layers; j++) {
                if (arr[i][j].pageItems.length) {
                    doCyclePageItemAndTextToPath(arr[i][j].pageItems, num)
                }
            }
        }
    }
}

function parsingPageItems(arr, num, exportFileInfo, savePath, recordInfo) {
    //num 为层级深度 recordInfo 为计算整体要导出的元素数量
    if (!arr.length) {
        return
    }
    var parent = arr[0].parent;

    if (judgeLayerClip(arr)) {
        if (recordInfo) {
            recordInfo.eleNumber++
            return
        }
        var clipTextToPath = 0
        // doCyclePageItemAndTextToPath(arr, clipTextToPath)
        parent.hidden = false;
        var path = exportFileAsSvgA(savePath);
        var imgInfo = packageImgObj(parent, path, "svg");
        exportFileInfo.push(imgInfo);
        if (clipTextToPath) {
            // hidden的显示也是一步操作
            for (var j = 0; j < clipTextToPath.length + 1; j++) {
                // 返回原来的
                app.documents.undo();
            }
        } else {
            parent.hidden = true;
        }
        // parent.hidden = true;
        return;
    }
    if (arr.length > 10 || num > 3) {
        if (parent.typename === "GroupItem") {
            if (recordInfo) {
                recordInfo.eleNumber++
                return
            }
            var deepTextToPath = 0
            // doCyclePageItemAndTextToPath(arr, deepTextToPath)
            parent.hidden = false;
            // var path = exportPNG24A(savePath);
            var path = exportFileAsSvgA(savePath);
            var imgInfo = packageImgObj(parent, path, "svg");
            exportFileInfo.push(imgInfo);
            if (deepTextToPath) {
                // hidden的显示也是一步操作
                for (var j = 0; j < deepTextToPath.length + 1; j++) {
                    // 返回原来的
                    app.documents.undo();
                }
            } else {
                parent.hidden = true;
            }
            return;
        }
        // 如果父级是layer 不做处理
    }
    // 隐藏全部 pageitem
    if (arr.length > 1) {
        resetAllVisiable(arr, false);
    }
    for (var i = 0; i < arr.length; i++) {

        if (arr[i].typename === "TextFrame") {

        } else if (arr[i].typename === "RasterItem") {
            if (!arr[i].opacity) continue;
            if (recordInfo) {
                recordInfo.eleNumber++
            } else {
                arr[i].hidden = false;
                var path = exportPNG24A(savePath);
                var imgInfo = packageImgObj(arr[i], path, "png");
                exportFileInfo.push(imgInfo);
                arr[i].hidden = true;
            }

        } else if (
            arr[i].typename === "PathItem" ||
            arr[i].typename === "GraphItem" ||
            arr[i].typename === "CompoundPathItem"
        ) {
            if (!arr[i].opacity) continue;

            arr[i].hidden = false;
            var path = exportFileAsSvgA(savePath);
            var imgInfo = packageImgObj(arr[i], path, "svg");
            exportFileInfo.push(imgInfo);
            arr[i].hidden = true;

        } else if (arr[i].typename === "GroupItem") {

            arr[i].hidden = false;
            num = num + 1;
            parsingPageItems(arr[i].pageItems, num, exportFileInfo, savePath, recordInfo);
            arr[i].hidden = true;
        } else {
            if (recordInfo) {
                recordInfo.eleNumber++
            } else {
                arr[i].hidden = false;
                var path = exportPNG24A(savePath);
                var imgInfo = packageImgObj(arr[i], path, "png");
                exportFileInfo.push(imgInfo);
                arr[i].hidden = true;
            }

        }


        if (arr[i].layers) {
            parsingLayer(arr[i].layers, exportFileInfo, saveFilePath);
        }
    }
    // 恢复全部 pageitem
    resetAllVisiable(arr, true);

}

function parsingTxtItems(arr, num, exportFileInfo, savePath, recordInfo, recordTxtPage) {
    //num 为层级深度 recordInfo 为计算整体要导出的元素数量
    if (!arr.length) {
        return
    }
    for (var i = 0; i < arr.length; i++) {
        $.write(arr[i].typename, i);
        if (arr[i].typename === "TextFrame") {
            recordTxtPage.push(arr[i])
            // 有没有内容
            var aiTextFrom = aiParseText(arr[i]);
            // 是否转化SVG
            if (aiTextFrom) {
                exportFileInfo.push(aiTextFrom);
            }
            arr[i].hidden = true;

        } else if (arr[i].typename === "GroupItem") {
            num = num + 1;
            parsingTxtItems(arr[i].pageItems, num, exportFileInfo, savePath, recordInfo, recordTxtPage);
        }
        if (arr[i].layers) {
            parsingLayer(arr[i].layers, exportFileInfo, saveFilePath, 'parseTxt');
        }
    }
}

function parsingLayer(layers, exportFileInfo, saveFilePath, recordInfo, isParseTxt, recordTxtPage) {
    for (var i = 0; i < layers.length; i++) {
        // 跳过刀线图层
        if (layers[i].name.indexOf("删改或移动") !== -1) {
            continue;
        }
        if (layers[i].locked) {
            continue;
        }

        // 若存在多图层,在处理当前图层时隐藏其他图层
        if (layers.length > 1) {
            resetAllLayersVisiable(layers, false);
            layers[i].visible = true;
        }
        // debugger;

        // 拿到所有的PageItems
        var layerPageItems = layers[i].pageItems;
        if (!layerPageItems.length) {
            continue
        }
        var num = 0;
        if (isParseTxt) {
            parsingTxtItems(layerPageItems, num, exportFileInfo, saveFilePath, recordInfo, recordTxtPage);

        } else {
            parsingPageItems(layerPageItems, num, exportFileInfo, saveFilePath, recordInfo);

        }
        // 下面可能还有layers
        if (layers[i].layers) {
            parsingLayer(layers[i], exportFileInfo, saveFilePath, recordInfo, isParseTxt, recordTxtPage);
        }
    }
    // 恢复全部图层显示
    resetAllLayersVisiable(layers, true);

}

function getParsingAiLength() {
    var exportFileInfo = [];
    var saveFilePath = "";
    var recordInfo = new Object()
    recordInfo.eleNumber = 0
    var documentsLayer = app.activeDocument.layers;
    parsingLayer(documentsLayer, exportFileInfo, saveFilePath, recordInfo);
    return recordInfo.eleNumber
}

function parsingAiWithAllTxt(saveFilePath) {
    var exportFileInfo = [];
    var txtResult = parsingAitxt()
    var txtLayerInfo = txtResult.txtLayerInfo
    var recordTxtPage = txtResult.recordTxtPage
    var saveFilePath = "/Users/mingo/Documents/aipic/";
    // 获取layers
    var documentsLayer = app.activeDocument.layers;
    parsingLayer(documentsLayer, exportFileInfo, saveFilePath);
    var sumInfo = exportFileInfo.concat(txtLayerInfo)
    // var a = Object.c(txtLayerInfo, exportFileInfo)

    // 恢复记录的所有文字图层的显示
    for (var i = 0; i < recordTxtPage.length; i++) {
        recordTxtPage[i].hidden = false;
    };
    return JSON.stringify(sumInfo);
    // return exportFileInfo);
}

function parsingAitxt(saveFilePath) {
    var txtLayerInfo = [];
    var recordTxtPage = []
    var saveFilePath = "/Users/mingo/Documents/aipic/";
    // 获取layers
    var documentsLayer = app.activeDocument.layers;
    // debugger
    parsingLayer(documentsLayer, txtLayerInfo, saveFilePath, false, 'parseTxt', recordTxtPage);

    var result = new Object()
    result.txtLayerInfo = txtLayerInfo
    result.recordTxtPage = recordTxtPage
    return result;
}

// parsingAiWithAllTxt();
// getParsingAiLength()